{ This is the input data:  N;  S1 h1 m1;  S2 h2 m2;  ...;  S(N) h(N) m(N).
 5
 28 3 40
 4 4 60
 10 2 30
 16 2 50
 1 5 20

                                 
                                -----------
                           (Created by Darkness)

       N (N<=250) ,         
 ,   .        
     -   -    .  
       .       -
  ,        .

:
             "A : array[1..250] of TA", 
       p   ,    (. Lic, Vis, Teg).  
               .. 
       i<=j  A[i].Lic >= A[j].Lic.      :
       A[1] = (28,3,40)
       A[2] = (16,2,50)
       A[3] = (10,2,30)
       A[4] = (4,4,60)
       A[5] = (1,5,20).                ,  
             b[j] (j:=1 to K; b[j] <= b[j+1])
            1..N,   
           -     ..  i<j
        A[ b[i] ].Teg > A[ b[j] ].Teg,     
        .. Sum( A[b[i]].Vis;  i:=1 to K)  .

:
           "Quick Sort".    
       .  "Ans"     -  
       .    ,    
         "Max"     
       - ,       (  -) 
                .
          A[i].Max := A[i].Vis
          A[i].Max := Max( A[i].Max, A[i].Vis+A[j].Max )
             j:=1 to i-1    A[j].Teg > A[i].Teg     (*)

       .. "Max"        -
            "Max"   ,  
               .  
            ,    
          .       
       ,        .
          A[1] = (28,3,40)         [1].Max = 3;
          A[2] = (16,2,50)         A[2].Max = 2;
          A[3] = (10,2,30)         A[3].Max = Max(2, 3+2, 2+2) = 5;
          A[4] = (4,4,60)          A[4].Max = 4;
          A[5] = (1,5,20)          A[5].Max = Max(5, 3+5, 2+5, 5+5, 4+5)=10;

     (*)     A[i].Lic = A[j].Lic,     
          ,     :
            (A[j].Teg > A[i].Teg) and (A[i].Lic <> A[j].Lic)


  28.III.1999                                                    Darkness

}

{$G+,Q-,R-,S-,M 65520,0,655360}
program High_Tower;
const
     InFile  = 'TOW2.PAS';
     OutFile = '';
type
    TA = record
           Lic, Vis, Teg, Max : Word;
         end;
var
   Ans : Word;
   A   : array[1..250] of TA;
   N   : Byte;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure  Sort(L, R : Byte);
var
   I, J : Byte;
   Y    : TA;
   X    : Word;
begin
  I := L; J := R; X := A[(I+J) div 2].Lic;
 repeat
  while A[I].Lic > X do Inc(I);
  while A[J].Lic < X do Dec(J);
  if I <= J then
    begin Y := A[I]; A[I] := A[J]; A[J] := Y; Inc(I); Dec(J); end;
 until I > J;
 if I < R then Sort(I,R);
 if J > L then Sort(L,J);
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure InPut;
var
   F : Text;
   I : Byte;
begin
  Assign(F, InFile);
  ReSet(F);
  ReadLn(F);
  ReadLn(F,N);
 for I := 1 to N do ReadLn(F,A[I].Lic,A[I].Vis,A[I].Teg);
  Close(F);
  Sort(1,N);
  Ans := 0;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Go;
var
   I, J : Byte;
   Z    : Word;
begin
 for I := 1 to N do
   begin
     A[I].Max := A[I].Vis;
    for J := 1 to I-1 do
     if (A[J].Teg > A[I].Teg) and (A[I].Lic <> A[J].Lic) then
      begin
        Z := A[J].Max + A[I].Vis;
       if (Z > A[I].Max) then A[I].Max := Z;
      end;
    if A[I].Max > Ans then Ans := A[I].Max;
   end;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure OutPut;
var F : Text;
begin
  Assign(F, OutFile);
  ReWrite(F);
  WriteLn(F, Ans);
  Close(F);
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
begin
  InPut;
  Go;
  OutPut;
end.
